unit unit1;

interface

{
The various properties of TWordReport are
MasterDataset - The master DataSet
DetailDataset - The detail DataSet (if any)
Preview - Whether to preview or print
TemplateName - Name of the .dot file.

The fields which must be printed must be made visible. This component
assumes that for each visible field in the master dataset, there is a
form field in the template file of the same name. For each visible field
in the detail dataset, a column is assumed in the table.

This example uses the tables from DBDEMOS alias to print the report.
It shows a typical master-detail report.
}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, WordReport, StdCtrls;

type
  TfReport = class(TForm)
    WordReport: TWordReport;
    qyMaster: TQuery;
    qyDetail: TQuery;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    dsMaster: TDataSource;
    qyMasterOrderNo: TFloatField;
    qyMasterShipDate: TDateTimeField;
    qyMasterEmpNo: TIntegerField;
    qyDetailItemNo: TFloatField;
    qyDetailPartNo: TFloatField;
    qyDetailVendorNo: TFloatField;
    qyDetailQty: TIntegerField;
    qyMasterCustNo: TFloatField;
    qyMasterSaleDate: TDateTimeField;
    qyMasterShipToContact: TStringField;
    qyMasterShipToAddr1: TStringField;
    qyMasterShipToAddr2: TStringField;
    qyMasterShipToCity: TStringField;
    qyMasterShipToState: TStringField;
    qyMasterShipToZip: TStringField;
    qyMasterShipToCountry: TStringField;
    qyMasterShipToPhone: TStringField;
    qyMasterShipVIA: TStringField;
    qyMasterPO: TStringField;
    qyMasterTerms: TStringField;
    qyMasterPaymentMethod: TStringField;
    qyMasterItemsTotal: TCurrencyField;
    qyMasterTaxRate: TFloatField;
    qyMasterFreight: TCurrencyField;
    qyMasterAmountPaid: TCurrencyField;
    qyMasterCustNo_1: TFloatField;
    qyMasterCompany: TStringField;
    qyMasterAddr1: TStringField;
    qyMasterAddr2: TStringField;
    qyMasterCity: TStringField;
    qyMasterState: TStringField;
    qyMasterZip: TStringField;
    qyMasterCountry: TStringField;
    qyMasterPhone: TStringField;
    qyMasterFAX: TStringField;
    qyMasterTaxRate_1: TFloatField;
    qyMasterContact: TStringField;
    qyMasterLastInvoiceDate: TDateTimeField;
    qyDetailOrderNo: TFloatField;
    qyDetailDiscount: TFloatField;
    qyDetailPartNo_1: TFloatField;
    qyDetailDescription: TStringField;
    qyDetailOnHand: TFloatField;
    qyDetailOnOrder: TFloatField;
    qyDetailCost: TCurrencyField;
    qyDetailListPrice: TCurrencyField;
    procedure Button1Click(Sender: TObject);
    procedure WordReportPageHeaderPrint(Sender: TWordReport;
      var Word: OleVariant);
    procedure WordReportDetailPrint(Sender: TWordReport;
      var Word: OleVariant);
    procedure WordReportPageFooterPrint(Sender: TWordReport;
      var Word: OleVariant);
  private
    { Private declarations }
    qty: double;
  public
    { Public declarations }
  end;

var
  fReport: TfReport;

implementation

{$R *.DFM}

procedure TfReport.Button1Click(Sender: TObject);
begin
  with qyMaster do
  begin
    Close;
    ParamByName('Company').AsString:=edit1.Text;
    Open;
  end;
  WordReport.Execute;
end;

procedure TfReport.WordReportPageHeaderPrint(Sender: TWordReport;
  var Word: OleVariant);
begin
  qty:=0;
end;

procedure TfReport.WordReportDetailPrint(Sender: TWordReport;
  var Word: OleVariant);
begin
  qty:=qty+qyDetailQty.Value;
end;             

procedure TfReport.WordReportPageFooterPrint(Sender: TWordReport;
  var Word: OleVariant);
var
  v, ff:OleVariant;
begin
  ff:=Word.ActiveDocument.FormFields;
  v:='SumQty';
  ff.Item(v).Result:=FloatToStr(qty);
end;

end.
